import jp.ac.takushoku_u.cs.*;

/**
* IRSAnalysisNX̃eXgpNX
* @version 1.0
* @author } Tj(Kasajima Hiroshi)
*/
/*
* ŏIXV 2005N0108
*/
class IRSAnalysisTest{

public static void main(String[] args){

	double[][] sampleData = {
		{1,1,1,1,1,1},
		{1,1,1,1,1,1},
		{0,1,1,0,0,0},
		{0,1,1,0,0,0},
		{0,1,1,0,1,1},
		{0,0,1,0,1,1},
		{0,0,1,1,1,1},
		{0,0,0,1,1,1},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}};
	
	String[] rowName = {"k1","k2","k3","k4","k5",
		"k6","k7","k8","k9","k10"};
	String[] colName = {"1","2","3","4","5","6"};
	
	//͂s}gNX̐
	ArithmeticMatrix dataMatrix = new ArithmeticMatrix(sampleData, rowName, colName);
	
	//͂s
	IRSAnalysis result = new IRSAnalysis(dataMatrix);
	
	//l̐ݒ
	result.setThreshold(0.5);
	
	//͑Ώۂ̃}gNX̏o
	
	//o͗p}gNX̐
	ArithmeticMatrix outMatrix = new ArithmeticMatrix(10,6);
	System.out.println("̃}gNX");
	//}gNX
	outMatrix.matrixCopy(result.getMatrix());
	//}gNX̏o
	outputMatrix(outMatrix);
	
	//W}gNX̏o
	ArithmeticMatrix outCofficient = new ArithmeticMatrix(6,6);
	outCofficient.matrixCopy(result.getCoefficientMatrix());
	System.out.println("W}gNX");
	outputDoubleMatrix(outCofficient);
	
	//͌ʂłIRS}gNX̏o
	ArithmeticMatrix outIRSMatrix = new ArithmeticMatrix(6,6);
	outIRSMatrix.matrixCopy(result.getIRSMatrix());
	System.out.println("IRS}gNX");
	outputMatrix(outIRSMatrix);
	
	//XPg}gNX̏o
	ArithmeticMatrix outSkeletonMatrix = new ArithmeticMatrix(6,6);
	outSkeletonMatrix.matrixCopy(result.getSkeletonMatrix());
	System.out.println("XPg}gNX");
	outputMatrix(outSkeletonMatrix);
	
	//}̊eԂ̏o
	//o͂0n܂vfԍŏo͂܂
	int[] col = new int[sampleData[0].length];
	System.arraycopy(result.getGraphElementArray(), 0, col, 0, col.length);
	System.out.print("}: ");
	for(int i = 0; i < col.length; i++){
		System.out.print((col[i]) + ", ");
	}
}
	
/**
* }gNXint^ŕWo͂ɏo͂܂B
*/
	private static void outputMatrix(ArithmeticMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//񖼏o
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//so
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+(int)outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+(int)outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
	
/**
* }gNXdouble^ŕWo͂ɏo͂܂B
*/
	private static void outputDoubleMatrix(ArithmeticMatrix outMatrix){
		java.text.NumberFormat df = new java.text.DecimalFormat("0.000");		//_ȉ3܂ŏo
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){
			System.out.print(outMatrix.getColName(j) + " ");		//񖼏o
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			System.out.print(outMatrix.getRowName(i) + "  ");		//so
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(df.format(outMatrix.getCell(i, j)));
				}
				else{
					System.out.print(df.format(outMatrix.getCell(i, j) )+" ");
				}
			}
		}
		System.out.println();
	}
	
}
