import jp.ac.takushoku_u.cs.*;
import java.util.Set;
import java.util.Iterator;
import java.util.TreeSet;

/**
* TaskPreTestNXTaskSequencePresumptionNX̃eXgpNXłB
* @version 1.0
* @author } Tj(Kasajima Hiroshi)
*/
/*
* ŏIXV2005N0110
*/

class TaskPreTest{
	public static void main(String[] args){
		double test1[][] = {
			{0,0,0,0,0,0,0,0},
			{1,0,0,0,0,0,0,0},
			{1,0,0,0,0,0,0,0},
			{0,1,0,0,0,0,0,0},
			{0,0,1,0,0,0,0,0},
			{0,0,0,1,0,0,0,0},
			{0,0,0,1,1,0,0,0},
			{0,1,0,0,1,0,0,0}};
		
		String[] name1 = {"vf1","vf2","vf3","vf4","vf5","vf6","vf7","vf8"};
		
		ArithmeticMatrix mat = new ArithmeticMatrix(test1, name1, name1);
		TaskSequence task = new TaskSequence(mat);
		
		//Sequence̐ݒ
		Sequence sq = new Sequence();
		sq.sequenceCopy(task.getTaskSequence(0.5,0.5));
		
		//n񉻂sn̏o
		System.out.println("sn");
		System.out.print("sԍ: ");
		for(int i = 0; i < mat.getRowLength(); i++){
			System.out.print(sq.getItem(i) + ",");
		}
		System.out.println();
		System.out.print("s: ");
		for(int i = 0; i < mat.getRowLength(); i++){
			System.out.print(sq.getItemName(i) + ",");
		}
		System.out.println();
		System.out.println();
		
		
		
		//炪eXgvO
		TaskSequencePresumption tsp = new TaskSequencePresumption(sq, mat);
		
		int vi = 4;		//I(ӁFڔԍł邽ߗvfԍ-1w肵܂j
		int vj = 5;		//Iڂɑ΂I\(I΂Ȃ)
						//vivjK؂ɑIĂȂꍇ͗O܂
		int k = 2;		//ی(1,2,3,4)
		
		//(1)A(2)A(2)/(1)̏o(At@)
		System.out.println(""+k+"یɂ I:"+mat.getRowName(vi)+" Ƃ̎̑I\:"+mat.getRowName(vj) );
		System.out.println("ɂ(1)A(2)A(2)/(1)̒l");
		System.out.println(tsp.getDiscriminantOneAlpha(vi,vj,k) + " , "
			+ tsp.getDiscriminantTwoAlpha(vi,vj,k) + " , " + tsp.getDiscriminantAlpha(vi,vj,k));
		
		//(1)A(2)A(2)/(1)̏o(x[^)
		System.out.println("ɂ(1)A(2)A(2)/(1)̒l");
		System.out.println(tsp.getDiscriminantOneBeta(vi,vj,k) + " , "
			+ tsp.getDiscriminantTwoBeta(vi,vj,k) + " , " + tsp.getDiscriminantBeta(vi,vj,k));
		
		System.out.println();
		System.out.println(""+k+"یɂ I:"+mat.getRowName(vi)+" Ƃ̎̑I\:"+mat.getRowName(vj) );
		System.out.println("̐");
		
		//w肵ځAیł̋߂
		Range ra = new Range();
		ra.rangeCopy(tsp.getAlphaPresumptionRange(vi,vj,k));
		
		//̏o
		//Ԃ̏o
		System.out.println(ra.getMin() + " <  < " + ra.getMax());
		//Ԃ̗[͊܂ނǂo true ȂΕs <=Afalse Ȃ < ƂȂ
		System.out.println("<=: "+ ra.hasMin() + " <=: " + ra.hasMax());
		//NaN(ԂȂ)̏ꍇ true
		System.out.println("W: "+ ra.isEmpty());
		
		//̏o
		Range ran = new Range();
		System.out.println();
		System.out.println("̐");
		ran.rangeCopy(tsp.getBetaPresumptionRange(vi,vj,k));
		System.out.println(ran.getMin() + " <  < " + ran.getMax());
		System.out.println("<=: "+ ran.hasMin() + " <=: " + ran.hasMax());
		System.out.println("W: "+ ran.isEmpty());
		
		
		//Ax֐1ƂȂԂ̏o
		System.out.println();
		System.out.println(""+k+"ی̂ƂAx֐1ɂȂ");
		ra.rangeCopy(tsp.getAlphaRange(k));
		System.out.println(ra.getMin() + " <  < " + ra.getMax());
		System.out.println("<=: "+ ra.hasMin() + " <=: " + ra.hasMax());
		System.out.println("W: "+ ra.isEmpty());
		
		System.out.println();
		ra.rangeCopy(tsp.getBetaRange(k));
		System.out.println(ra.getMin() + " <  < " + ra.getMax());
		System.out.println("<=: "+ ra.hasMin() + " <=: " + ra.hasMax());
		System.out.println("W: "+ ra.isEmpty());
		
		//̎肤͈͂̏Wo
		System.out.println();
		System.out.println("̍ڂƂ̐茋");
		RangeSet hashSet = new RangeSet(tsp.getAlphaRangeSet(k));
		Iterator i = hashSet.iterator();
    	while(i.hasNext()){
    		Range ed = (Range)i.next();
    		
    		System.out.println(ed.getMin() + " <  < " + ed.getMax());
			System.out.println("<=: "+ ed.hasMin() + " <=: " + ed.hasMax());
			System.out.println("W: "+ ed.isEmpty());
    	}
		
		//Ax֐̒l̏o
		System.out.println();
		Set setx = new TreeSet(tsp.getAlphaAttributeSet(k));
		Iterator ix = setx.iterator();
		while(ix.hasNext()){
			Double dx = (Double)ix.next();
			double x = dx.doubleValue();
			if(Double.isNaN(x) == false){
				System.out.println(x + "̂Ƃ̋Ax֐̒l");
				System.out.println(tsp.getBetaAttribute(k,x));
			}
		}
		
		//lł̋Ax֐̒lƕω郿̒l̏W
		System.out.println();
		System.out.println("=0̂Ƃ̋Ax֐: "+tsp.getAlphaAttribute(k,0));
		System.out.println("̕ω_: "+ tsp.getAlphaAttributeSet(k));
		
		//̎肤͈͂̏Wo
		System.out.println();
		System.out.println("̍ڂƂ̐茋");
		hashSet = new RangeSet(tsp.getBetaRangeSet(k));
		i = hashSet.iterator();
    	while(i.hasNext()){
    		Range ed = (Range)i.next();
    		
    		System.out.println(ed.getMin() + " <  < " + ed.getMax());
			System.out.println("<=: "+ ed.hasMin() + " <=: " + ed.hasMax());
			System.out.println("W: "+ ed.isEmpty());
    	}
		
		//Ax֐̒l̏o
		System.out.println();
		Set sety = new TreeSet(tsp.getBetaAttributeSet(k));
		Iterator iy = sety.iterator();
		while(iy.hasNext()){
			Double dy = (Double)iy.next();
			double y = dy.doubleValue();
			if(Double.isNaN(y) == false){
				System.out.println(y + "̂Ƃ̋Ax֐̒l");
				System.out.println(tsp.getBetaAttribute(k,y));
			}
		}
		
		//lł̋Ax֐̒lƕω̒l̏W
		System.out.println();
		System.out.println("=0̂Ƃ̋Ax֐: "+tsp.getBetaAttribute(k,0));
		System.out.println("̕ω_: "+ tsp.getBetaAttributeSet(k));
		
	}
	
/**
* }gNXint^ŕWo͂ɏo͂܂B
* @param outMatrix oׂ͂}gNX
*/
	private static void outputMatrix(ArithmeticMatrix outMatrix){
		System.out.print("        ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//񖼏o
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + "  ");		//so
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+(int)outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+(int)outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
	
/**
* }gNXdouble^ŕWo͂ɏo͂܂B
* @param outMatrix oׂ͂}gNX
*/
	private static void outputDoubleMatrix(ArithmeticMatrix outMatrix){
		java.text.NumberFormat df = new java.text.DecimalFormat("0.00");		//_ȉ2܂ŏo
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){
			System.out.print(outMatrix.getColName(j) + " ");		//񖼏o
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			System.out.print(outMatrix.getRowName(i) + "  ");		//so
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(df.format(outMatrix.getCell(i, j)));
				}
				else{
					System.out.print(df.format(outMatrix.getCell(i, j) )+"  ");
				}
			}
		}
		System.out.println();
	}
}